"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
// eslint-disable-next-line @typescript-eslint/no-unused-vars
const react_1 = require("react");
const SequencePanel_1 = __importDefault(require("@jbrowse/core/BaseFeatureWidget/SequencePanel"));
const assembleBundle_1 = require("../assembleBundle");
function GenericSeqPanel({ nclistbaseurl, fastaurl, refseq, mode, start, end, gene, transcript, urltemplate, }) {
    const [result, setResult] = (0, react_1.useState)();
    const [error, setError] = (0, react_1.useState)();
    (0, react_1.useEffect)(() => {
        (() => __awaiter(this, void 0, void 0, function* () {
            try {
                const res = yield (0, assembleBundle_1.assembleBundle)({
                    nclistbaseurl,
                    urltemplate,
                    fastaurl,
                    gene,
                    transcript,
                    refseq,
                });
                setResult(res);
            }
            catch (e) {
                console.error(e);
                setError(e);
            }
        }))();
    }, [
        refseq,
        transcript,
        gene,
        start,
        end,
        fastaurl,
        urltemplate,
        nclistbaseurl,
    ]);
    if (error) {
        return (0, jsx_runtime_1.jsx)("div", Object.assign({ style: { color: "red" } }, { children: `${error}` }));
    }
    else if (!result) {
        return (0, jsx_runtime_1.jsx)("div", { children: "Loading..." });
    }
    else {
        return ((0, jsx_runtime_1.jsx)("div", Object.assign({ className: "GenericSeqPanel" }, { children: (0, jsx_runtime_1.jsx)(SequencePanel_1.default, { mode: mode, sequence: result.sequence, feature: result.feature }) })));
    }
}
exports.default = GenericSeqPanel;
