import { jsx as _jsx } from "react/jsx-runtime";
// eslint-disable-next-line @typescript-eslint/no-unused-vars
import { useState, useEffect } from "react";
import SequencePanel from "@jbrowse/core/BaseFeatureWidget/SequencePanel";
import { assembleBundle } from "../assembleBundle";
export default function GenericSeqPanel({ nclistbaseurl, fastaurl, refseq, mode, start, end, gene, transcript, urltemplate, }) {
    const [result, setResult] = useState();
    const [error, setError] = useState();
    useEffect(() => {
        (async () => {
            try {
                const res = await assembleBundle({
                    nclistbaseurl,
                    urltemplate,
                    fastaurl,
                    gene,
                    transcript,
                    refseq,
                });
                setResult(res);
            }
            catch (e) {
                console.error(e);
                setError(e);
            }
        })();
    }, [
        refseq,
        transcript,
        gene,
        start,
        end,
        fastaurl,
        urltemplate,
        nclistbaseurl,
    ]);
    if (error) {
        return _jsx("div", { style: { color: "red" }, children: `${error}` });
    }
    else if (!result) {
        return _jsx("div", { children: "Loading..." });
    }
    else {
        return (_jsx("div", { className: "GenericSeqPanel", children: _jsx(SequencePanel, { mode: mode, sequence: result.sequence, feature: result.feature }) }));
    }
}
